**Cette page a été importée automatiquement de notre ancien wiki mais n'a pas encore été révisée.**

# Howto BTRFS

*_Wikipedia*_
Btrfs (B-tree file system, prononcé ButterFS) est un système de fichiers des années 2010 fondé sur le Copy-On-Write (copie sur écriture en français) sous licence GNU GPL, développé conjointement par Oracle, Red Hat, Fujitsu, Intel, SUSE, STRATO AG (en) et autres. En 2012, alors qu'il n'était pas encore considéré comme tout-à-fait stable, un effort intense de développement et de test est fourni par la communauté afin de faire de Btrfs le successeur de ext4 et ext3, systèmes de fichiers habituels des distributions Linux. OpenSuse 13.2 propose dès son lancement Btrfs par défaut pour la partition racine afin d'assurer la sécurité et laisse le choix entre ext4 et XFS (plus rapide) pour /home. 

Btrfs offre les fonctionnalités suivantes absentes d'autres systèmes de fichiers :

- Instantané (snapshots)
- somme de contrôle

Ces caractéristiques sont importantes pour les systèmes Linux, serveurs comme postes clients, car les tailles de stockage comme les configurations tendent à augmenter et à se complexifier. 


On commence par installer le paquet nécéssaire

~~~
# apt install btrfs-tools
~~~

On formate la partition

~~~
mkfs.btrfs /dev/sda9
~~~

Montage

~~~
echo "/dev/sda9 /backup         btrfs    defaults        0       0" >> /etc/fstab
mount /backup
~~~

On créé des subvolume

~~~
btrfs subvolume create /backup/aaa
btrfs subvolume create /backup/bbb
~~~

Lister les subvolumes

~~~
btrfs subvolume list /backup/
~~~

On peut faire des snapshots

~~~
btrfs subvolume snapshot /backup/aaa /backup/bbb/snapshot1
~~~

On peut supprimer des subvolumes (et snapshots)

~~~
btrfs subvolume delete /bbb/bbb/snapshot1
~~~

Vérifier l'intégrité 
~~~
btrfs scrub start /backup/
btrfs scrub status /backup/
~~~

Check plus poussé sur une partition non montée

~~~
btrfs check -p /dev/sda9
~~~

Voir si la partition a présenté des erreurs

~~~
btrfs dev stats /backup
~~~

Sources :
[<https://fr.wikipedia.org/wiki/Btrfs>]
[<https://wiki.debian.org/Btrfs>]
[<https://btrfs.wiki.kernel.org/index.php/Getting_started#Basic_Filesystem_Commands>]
[<https://btrfs.wiki.kernel.org/index.php/SysadminGuide>]