**Cette page a été importée automatiquement de notre ancien wiki mais n'a pas encore été révisée.**

Nous allons voir comment mettre en place rapidement un serveur de boot PXE pour installer un système via le réseau.

Nous allons installer 3 serveurs :

* un serveur DHCP, pour fournir les informations réseau à la machine ;
* un serveur TFTP, pour le transfert des fichiers nécessaires au boot ;
* et bien sûr, le serveur PXE en lui même.

Packets nécessaires :

~~~
# aptitude install dhcp3-server pxe atftpd
~~~

## Configuration du réseau

*Attention :* Pour éviter d'interférer avec le serveur DHCP de votre réseau, il est nécessaire de recréer un second réseau, à l'aide d'un switch par exemple, et isolé de votre premier réseau.

### Attribution d'une IP à la carte réseau

On fixe l'adresse IP du serveur PXE :

~~~
ifconfig eth0 192.168.0.254
~~~

### Configuration du serveur DHCP

Premièrement, il faut renseigner les interfaces gérées dans le fichier _/etc/default/dhcp3-serveur_

~~~
INTERFACES="eth0"
~~~

Ensuite, nous décrivons la configuration réseau dans le fichier _/etc/dhcp3/dhcpd.conf_

~~~
subnet 192.168.0.0 netmask 255.255.255.0
{
    range 192.168.0.1 192.168.0.100;
    option routers 192.168.0.100;
    option subnet-mask 255.255.255.0;
    option broadcast-address 192.168.0.255;
    filename "/debian-5.0-amd64/pxelinux.0";
}
~~~

L'option filename indique le chemin (à partir du chroot du serveur TFTP) du fichier image à booter.

## Configuration du serveur TFTP

Nous utilisons atftp comme serveur TFTP. Aucune configuration n'est nécessaire, il est fonctionnel dès l'installation. Par défaut il est lancé par inetd. Pour désactiver ce comportement, remplacez la ligne `USE_INETD=true` par `false`.

Suivant si inetd est utilisé ou pas, il est possible de modifier les options de atftpd, soit dans le fichier _/etc/inetd.conf_ soit dans le fichier _/etc/default/atftp_.

À l'installation, un répertoire /tftpboot est créé. Il contient les fichiers qui seront servit par atftpd.

## Configuration de PXE

La configuration se fait dans le fichier _/etc/pxe.conf_

TODO rdessort : à  terminer suivant la conf de l'eeepc
